/*
	Coded by Fatalis (FatalisDK@hotmail.com)
	
	Sites:
	http://kzm.hellrazers.net
	http://hellrazers.net
	http://drivenservers.com
	http://xtreme-jumps.net
	http://kz-usa.com
	
	Servers:
	KZ Monkeys - 24/7 KZ Maps - 20 slot NY Boosted - hrkz.servegame.com:27017
	
	Chat Commands:
	/ljstats - Displays jump length, prestrafe speed, and air speed when you land a LJ.
	/speed - Displays your current units per second speed.
	/ljrec - Displays current game's LJ record.
	/savedljrec - Displays the LJ record saved to file.
	
	Console Commands:
	amx_resetsavedljrec - Resets the saved LJ record.
	amx_resetljrec - Resets the current game's LJ record.
*/

#include <amxmodx>
#include <amxmisc>
#include <fakemeta>

#pragma semicolon 1

#define FAST_SERVER

// Ints
new gBeam;
// Floats
//new Float:gSavedLjRec;
//new Float:gLjRec;
// Bools
new bool:gHasLjStats[33];
new bool:gInAir[33];
// Strings
//new gSavedLjName[35];
//new gLjName[33];
//new gFile[65];
new const gPLUGIN[] = "LongjumpStats";
new const gVERSION[] = "0.1";
new const gAUTHOR[] = "FatalisDK";

public plugin_init()
{
	register_plugin(gPLUGIN, gVERSION, gAUTHOR);
	
	register_cvar(gPLUGIN, gVERSION, FCVAR_SERVER);
	
	register_forward(FM_PlayerPreThink, "fwdPlayerPreThink", 0);
	register_forward(FM_Touch, "fwdTouch", 0);
	
	register_clcmd("say /ljstats", "cmdLjStats", -1, "");
	register_clcmd("say /speed", "cmdSpeed", -1, "");
	register_clcmd("say /ljrec", "cmdLjRec", -1, "");
/*	register_clcmd("say /savedljrec", "cmdSavedLjRec", -1, ""); */
/*	register_clcmd("amx_resetsavedljrec", "cmdResetSavedLjRec", ADMIN_BAN, ""); */
/*	register_clcmd("amx_resetljrec", "cmdResetLjRec", ADMIN_BAN, ""); */
	register_cvar("amx_kreedz_maxlj","260");
	register_cvar("amx_kreedz_goodlj","240");
	register_cvar("amx_kreedz_minlj","210.0");
	
/*	loadRec(); */
}

/*loadRec()
*{
*	get_datadir(gFile, 64);
*	
*	add(gFile, 64, "/kzm", 0);
*	
*	if( !dir_exists(gFile) )
*	{
*		mkdir(gFile);
*	}
*	
*	add(gFile, 64, "/ljrec.txt", 0);
*	
*	new szData[65], szLjRec[13];
*	new f = fopen(gFile, "rt");
*	fgets(f, szData, 64);
*	parse(szData, gSavedLjName, 34, szLjRec, 12);
*	fclose(f);
*	
*	replace_all(gSavedLjName, 34, "^"", "");
*	gSavedLjRec = str_to_float(szLjRec);
*	
*	if( gSavedLjRec == 0.0 )
*	{
*		copy(gSavedLjName, 34, "Noone");
*	}
*}
*
*
*public plugin_end()
*{
*	new szData[65];
*	format(szData, 64, "^"%s^" %f", gSavedLjName, gSavedLjRec);
*	
*	new f = fopen(gFile, "wt");
*	fputs(f, szData);
*	fclose(f);
*}
*/
public plugin_precache()
{
	gBeam = precache_model("sprites/zbeam4.spr");
}

public client_disconnect(id)
{
	gHasLjStats[id] = false;
	
	if( task_exists(id+334490, 0) )
	{
		remove_task(id+334490, 0);
	}
}

/*public cmdResetSavedLjRec(id, level, cid)
*{
*	if( !cmd_access(id, level, cid, 1) )
*	{
*		return PLUGIN_HANDLED;
*	}
*	
*	copy(gSavedLjName, 34, "Noone");
*	gSavedLjRec = 0.0;
*	
*	client_print(id, print_console, "[KZ] Done!");
*	
*	return PLUGIN_HANDLED;
*}
*
*public cmdResetLjRec(id, level, cid)
*{
*	if( !cmd_access(id, level, cid, 1) )
*	{
*		return PLUGIN_HANDLED;
*	}
*	
*	copy(gLjName, 34, "Noone");
*	gLjRec = 0.0;
*	
*	client_print(id, print_console, "[KZ] Done!");
*	
*	return PLUGIN_HANDLED;
*}
*
*public cmdSavedLjRec(id)
*{
*	client_print(id, print_chat, "[KZM] SAVED LJ Record: %s | %f.", gSavedLjName, gSavedLjRec);
*	
*	return PLUGIN_CONTINUE;
*}
*
*public cmdLjRec(id)
*{
*	//client_print(id, print_chat, "[KZM] UNSAVED LJ Record: %s | %f.", gLjName, gLjRec);
*	client_print(id, print_chat, "[KZM] LJ record made by: %s | %f.", gLjName, gLjRec);
*	
*	return PLUGIN_CONTINUE;
*}
*/
public cmdSpeed(id)
{
	if( !task_exists(id+334490, 0) )
	{
		#if defined FAST_SERVER
		set_task(0.1, "tskSpeed", id+334490, "", 0, "b", 0);
		#else
		set_task(0.5, "tskSpeed", id+334490, "", 0, "b", 0);
		#endif
		
		client_print(id, print_chat,
			"[KZM] Speedometer enabled.  To disable, type /speed.");
	}
	else
	{
		remove_task(id+334490, 0);
		
		client_print(id, print_chat, "[KZM] Speedometer disabled.");
	}
	
	return PLUGIN_CONTINUE;
}

public tskSpeed(taskid)
{
	taskid-=334490;
	
	if( is_user_alive(taskid) )
	{
		static Float:vVelocity[3];
		pev(taskid, pev_velocity, vVelocity);
		
		#if defined FAST_SERVER
		set_hudmessage(255, 255, 255, -1.0, 0.65, 0, 0.0, 0.1, 0.0, 0.0, 2);
		#else
		set_hudmessage(255, 255, 255, -1.0, 0.65, 0, 0.0, 0.5, 0.0, 0.0, 2);
		#endif
		
		show_hudmessage(taskid, "%f", vector_length(vVelocity));
	}
}

public cmdLjStats(id)
{
	if( !gHasLjStats[id] )
	{
		gHasLjStats[id] = true;
		
		client_print(id, print_chat,
			"[KZM] Longjump Stats enabled.  To disable, type /ljstats.");
	}
	else
	{
		gHasLjStats[id] = false;
		
		client_print(id, print_chat,
			"[KZM] Longjump Stats disabled.");
	}
	
	return PLUGIN_CONTINUE;
}

public fwdPlayerPreThink(id)
{
	if( is_user_alive(id) )
	{
		static Float:vJumpedAt[33][3];
		static Float:vOrigin[3];
		static Float:vAngles[3];
		static Float:vTraceEnd[3];
		static Float:fMaxAirSpeed[33];
		static Float:fMaxGroundSpeed[33];
		static Float:vVelocity[3];
		static Float:fSpeed;
		static clip, ammo;
		
		if( pev(id, pev_speed) > 500 || get_user_weapon(id, clip, ammo) == CSW_SCOUT )
		{
			gInAir[id] = false;
			return FMRES_IGNORED;
		}
		
		pev(id, pev_velocity, vVelocity);	
		fSpeed = vector_length(vVelocity);
		if( gInAir[id] == true )
		{
			if( fSpeed > fMaxAirSpeed[id] )
			{
				fMaxAirSpeed[id] = fSpeed;
			}
		}
		else
		{
			if( fSpeed > fMaxGroundSpeed[id] )
			{
				fMaxGroundSpeed[id] = fSpeed;
			}
		}
		
		if( pev(id, pev_button)&IN_JUMP
		&& pev(id, pev_flags)&FL_ONGROUND
		&& gInAir[id] == false)
		{
			gInAir[id] = true;
			
			pev(id, pev_origin, vOrigin);
			
			vOrigin[2]-=36.0;
			
			pev(id, pev_v_angle, vAngles);
			
			vOrigin[0]-=16.0*floatcos(vAngles[1], degrees);
			vOrigin[1]-=16.0*floatsin(vAngles[1], degrees);
			
			vJumpedAt[id][0] = vOrigin[0];
			vJumpedAt[id][1] = vOrigin[1];
			vJumpedAt[id][2] = vOrigin[2];
		}
		else if( pev(id, pev_flags)&FL_ONGROUND
		&& gInAir[id] == true )
		{
			gInAir[id] = false;
			
			pev(id, pev_origin, vOrigin);
			pev(id, pev_v_angle, vAngles);
			
			vOrigin[0]+=16.0*floatcos(vAngles[1], degrees);
			vOrigin[1]+=16.0*floatsin(vAngles[1], degrees);
			
			vTraceEnd[0] = vOrigin[0];
			vTraceEnd[1] = vOrigin[1];
			vTraceEnd[2] = vOrigin[2];
			vTraceEnd[2]-=64.0;
			
			static Float:vLandedAt[3];
			fm_trace_line(id, vOrigin, vTraceEnd, vLandedAt);
			
			static Float:fDistance;
			fDistance = get_distance_f(vJumpedAt[id], vLandedAt);
			
			if( vJumpedAt[id][2] == vLandedAt[2] && fDistance > get_cvar_num("amx_kreedz_minlj") )
			{
				if( gHasLjStats[id] )
				{
					message_begin(MSG_ONE, SVC_TEMPENTITY, {0, 0, 0}, id);
					write_byte (0);
					write_coord(floatround(vJumpedAt[id][0]));
					write_coord(floatround(vJumpedAt[id][1]));
					write_coord(floatround(vJumpedAt[id][2]));
					write_coord(floatround(vLandedAt[0]));
					write_coord(floatround(vLandedAt[1]));
					write_coord(floatround(vLandedAt[2]));
					write_short(gBeam);
					write_byte(1);
					write_byte(5);
					write_byte(30);
					write_byte(20);
					write_byte(0);
					write_byte(random_num(0, 255));
					write_byte(random_num(0, 255));
					write_byte(random_num(0, 255));
					write_byte(200);
					write_byte(200);
					message_end();
				
					set_hudmessage(255, 255, 255, -1.0, 0.70, 0, 0.0, 2.0, 0.1,
					0.1, 3);
					
					show_hudmessage(id,
						"Distance: %f^nMaxSpeed: %f^nPreStrafe: %f",
						fDistance, fMaxAirSpeed[id], fMaxGroundSpeed[id]);
						
					client_print(id, print_console,
						"Distance: %f AirSpeed: %f GroundSpeed: %f",
						fDistance, fMaxAirSpeed[id], fMaxGroundSpeed[id]);
				}
				new maxljd = get_cvar_num("amx_kreedz_maxlj");
				new minljd = get_cvar_num("amx_kreedz_goodlj");
/*				if( fDistance > gSavedLjRec
*				&& fDistance < ,maxljd )
*				{
*					gSavedLjRec = fDistance;
*					get_user_name(id, gSavedLjName, 34);
*					
*					client_print(0, print_chat,
*						"[KZM] %s now has the SAVED LJ Record: %f.",
*						gSavedLjName, fDistance);
*				}
*				
*				if( fDistance > gLjRec
*				&& fDistance < maxljd )
*				{
*					get_user_name(id, gLjName, 32);
*					
*					gLjRec = fDistance;
*					
*					client_print(0, print_chat,
*						"[KZM] %s now has the UNSAVED LJ Record: %f.",
*						gLjName, fDistance);
*				}
*/
				if( fDistance > minljd
				&& fDistance < maxljd )
				{
					new name[32];
					get_user_name(id, name, 31);
					client_print(0, print_chat,
						"[KZM] %s has jumped %f units!"
						,name, fDistance);
				}
			}
			
			fMaxAirSpeed[id] = 0.0;
			fMaxGroundSpeed[id] = 0.0;
		}
	}
	
	return FMRES_IGNORED;
}

public fwdTouch(ptr, ptd)
{
	static szClassname1[33];
	static szClassname2[33];
	
	pev(ptr, pev_classname, szClassname1, 32);
	pev(ptd, pev_classname, szClassname2, 32);
	
	if( equal(szClassname1, "player", 0)
	&& equal(szClassname2, "trigger_teleport", 0) )
	{
		gInAir[ptr] = false;
	}
	
}

fm_trace_line(ignoreEnt, const Float:vStart[3], const Float:vEnd[3], Float:vRet[3])
{
	engfunc(EngFunc_TraceLine, vStart, vEnd, ignoreEnt == -1 ? 1 : 0, ignoreEnt);

	new ent = global_get(glb_trace_ent);
	global_get(glb_trace_endpos, vRet);

	return pev_valid(ent) ? ent : 0;
}
